//include the library code:
#include <LiquidCrystal.h>

// initialize the library with the numbers of the interface pins
LiquidCrystal lcd(3,4,5,6,7,8);


// Threshold values for the led bar
#define TH1 45
#define TH2 95
#define TH3 200
#define TH4 400
#define TH5 600

// Conversion factor - CPM to uSV/h for J305β Geiger Tube
#define CONV_FACTOR 0.00812

// Variables
int ledArray [] = {10,11,12,13,9};
int geiger_input = 2;
long count = 0;
long countPerMinute = 0;
long timePrevious = 0;
long timePreviousMeassure = 0;
long time = 0;
long countPrevious = 0;
float uSvfast = 0.0;
float radiationValue = 0.0;

// count one measure at least
int minCount = 0;
// Average radiation measure

void setup(){
  pinMode(geiger_input, INPUT);
  digitalWrite(geiger_input,HIGH);
  for (int i=0;i<5;i++){
    pinMode(ledArray[i],OUTPUT);
  }

  Serial.begin(115200);

  //set up the LCD\'s number of columns and rows:
  lcd.begin(16, 2);
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("    *DAVIDS*");
  lcd.setCursor(0,1);
  lcd.print("*GEIGER TAELLER*");  
  delay(5000);


  attachInterrupt(0,countPulse,FALLING);
  lcd.clear();
  lcd.setCursor(0,0);  
  lcd.print(" *SAMLER  DATA* ");
  lcd.setCursor(0,1); 
  lcd.print("     *VENT*     ");
  delay(30000);
}

void loop(){
  //   unsigned long currentMillis = millis();

  if (millis()-timePreviousMeassure > 3000){
//  Smooth cpm to 1/5 current reading and 4/5 old reading = Reading takes about 15-20 seconds if radiation changes
    countPerMinute = ((20 * count) * 0.2) + (countPerMinute * 0.8);
// Smooth reading to 3/10 new reading and 7/10 old reading * Smoothing on cpm = Reading takes about 45 seconds to one minute if radiation changes  
    radiationValue = ((countPerMinute * CONV_FACTOR) * 0.3) + (radiationValue * 0.7);
    timePreviousMeassure = millis();
// usvfast follows cpm = 15 - 20 seconds to do a reading - This is only for measuring high levels of radiation     
    uSvfast = countPerMinute * CONV_FACTOR;
    
      
    lcd.clear();    
    lcd.setCursor(12,0);
    lcd.print("CPM");
    lcd.setCursor(12,1);
    lcd.print(countPerMinute);
    lcd.setCursor(0,0);
    lcd.print(radiationValue,4);
    lcd.setCursor(6,0);
    lcd.print("uSv/h");
    lcd.setCursor(6,1);
    lcd.print("uSv/h");  
    lcd.setCursor(0,1);
    lcd.print(uSvfast,4);
       
    
      
    //   led var setting  
    if(countPerMinute <= TH1) ledVar(0);
    if((countPerMinute <= TH2)&&(countPerMinute>TH1)) ledVar(1);
    if((countPerMinute <= TH3)&&(countPerMinute>TH2)) ledVar(2);
    if((countPerMinute <= TH4)&&(countPerMinute>TH3)) ledVar(3);
    if((countPerMinute <= TH5)&&(countPerMinute>TH4)) ledVar(4);
    if(countPerMinute>TH5) ledVar(5);

       count = 0;
       minCount++;
       }
  

       }



void countPulse(){
  detachInterrupt(0);
  count++;
  while(digitalRead(2)==0){
  }
  attachInterrupt(0,countPulse,FALLING);
  Serial.print(1);
}

void ledVar(int value){
  if (value > 0){
    for(int i=0;i<=value;i++){
      digitalWrite(ledArray[i],HIGH);
    }
    for(int i=5;i>value;i--){
      digitalWrite(ledArray[i],LOW);
    }
  }
  else {
    for(int i=5;i>=0;i--){
      digitalWrite(ledArray[i],LOW);
    }
  }
}
